



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Apache+Tomcat+Memcached实现会话保持</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Apache+Tomcat+Memcached实现会话保持</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-15 20:09:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1248689/201711/1248689-20171121112819446-1610851592.png" /></p>
<h2>会话保持的三种方式</h2>
<ul><ul><li>Session sticky会话绑定：通过在前端调度器的配置中实现统一session发送至同一后发端服务器</li>
<li>Session cluster会话集群：通过配置Tomcat保持所有Tomcat的session的信息一致。</li>
<li>Session server 会话服务：将所有的session交给专门的session服务管理。<br />这里讲解第三种，使用Memcached做session server</li></ul></ul>
<h2>一、架构图</h2>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1248689/201711/1248689-20171121112902133-190582311.png" /></p>
<h4>系统环境</h4>
<p>所有服务器全部采用<a href="http://www.linuxidc.com/topicnews.aspx?tid=14" rel="external nofollow noreferrer">CentOS</a>7.3</p>
<h4>所需要的软件包</h4>
<p>以下文件都要放置在tomcat服务器主机上的类库目录中</p>
<pre class="prettyprint linenums"><code>rpm -ql tomcat-lib                  #<br />
/usr/share/java/tomcat/             # yum安装默认在此目录<br />
/usr/local/tomcat/lib               # 在官网rpm安装的默认在此目录了</code></pre>
<pre class="prettyprint linenums"><code>memcached-session-manager-1.8.3.jar<br />
        http://repo1.maven.org/maven2/de/javakaffee/msm/memcached-session-manager/1.8.3/<br />
memcached-session-manager-tc7-1.8.3.jar<br />
        http://repo1.maven.org/maven2/de/javakaffee/msm/memcached-session-manager-tc7/1.8.3/<br />
spymemcached-2.11.1.jar<br />
        http://repo1.maven.org/maven2/net/spy/spymemcached/2.11.1/<br />
javolution-5.4.3.1.jar<br />
        http://memcached-session-manager.googlecode.com/svn/maven/javolution/javolution/5.4.3.1/<br />
msm-javolution-serializer-1.8.3.jar<br />
        http://repo1.maven.org/maven2/de/javakaffee/msm/msm-javolution-serializer/1.8.3/</code></pre>
<h2>二、Apache详细配置</h2>
<ul><li><p>安装httpd</p>
<pre class="prettyprint linenums"><code>yum install httpd</code></pre></li>
<li><p>创建配置文件<br />在<code>/etc/httpd/conf.d</code>下新建一个配置文件</p>
<pre class="prettyprint linenums"><code>shell &gt; vim /etc/httpd/conf.d/ajp-tomcat.conf<br />
#<br />
&lt;proxy balancer://tomcatservers&gt;                                        # 定义主机组<br />
    BalancerMember  ajp://172.18.68.21:8009 route=tomcatA<br />
    BalancerMember  ajp://172.18.68.22:8009 route=tomcatB<br />
    ProxySet lbmethod=byrequests<br />
&lt;/proxy&gt;<br />
#<br />
&lt;virtualhost *:80&gt;                                                      # 创建虚拟主机<br />
            ServerName www.baidu.com<br />
            ProxyVia On<br />
            ProxyRequests Off<br />
            ProxyPreserveHost On<br />
            proxyvia on<br />
            &lt;Proxy *&gt;<br />
                    Require all granted<br />
            &lt;/Proxy&gt;<br />
            ProxyPass / balancer://tomcatservers/                   # 设定所有调度至后端<br />
            ProxyPassReverse / balancer://tomcatservers/            # 设定所有调度至后端<br />
            &lt;Location /&gt;                                            # centos7默认拒绝，所以要允许<br />
                    Require all granted<br />
            &lt;/Location&gt;<br />
            &lt;Location /balancer-manager&gt;                            # apache的管理页面<br />
                    SetHandler balancer-manager<br />
                    ProxyPass !                                     # 匹配到apache的管理页面不代理<br />
                    Require all granted                             # 设定允许<br />
            &lt;/Location&gt;<br />
&lt;/virtualhost&gt;<br />
#<br />
shell &gt; systemctl start httpd</code></pre></li></ul>
<h2>三、Tomcat的配置</h2>
<p>两台tocat的配置大同小异，配置文件基本都相同，仅是后面创建的两个测试页面不同而已。</p>
<ul><li><p>安装Tomcat</p>
<pre class="prettyprint linenums"><code>yum install tomcat tomcat-admin-webapps  tomcat-webapps</code></pre></li>
<li><p>修改配置文件<br />在/etc/tomcat/下有个server.xml文件，打开这个文件后在host标签内添加或者修改如下配置。</p>
<pre class="prettyprint linenums"><code>vim /etc/tomcat/server.xml<br />
在host标签内配置以下内容<br />
&lt;Context path="/myapp" docBase="myapp"  reloadable="true"&gt;<br />
  &lt;Manager className="de.javakaffee.web.msm.MemcachedBackupSessionManager"<br />
       memcachedNodes="n1:172.18.68.31:11211,n2:172.18.68.32:11211"<br />
#n1:IP:prot为后端两个memcached地址<br />
#<br />
failoverNodes="n2"        # 设定n2备用。所以n1就是主<br />
requestUriIgnorePattern=".*\.(ico|png|gif|jpg|css|js)$"             # 匹配到这些结尾的文件不考虑cookie<br />
transcoderFactoryClass="de.javakaffee.web.msm.serializer.javolution.JavolutionTranscoderFactory"<br />
/&gt;<br />
&lt;/Context&gt;                  # 黄色标记部分为流式化管理工具，如果使用其他流式化工具，更改这两个名即可</code></pre></li>
<li><p>下载所依赖的软件包<br />将文章最开头提到的所有.jar文件结尾的文件软布放置在tomcat服务器主机上的类库目录中</p>
<pre class="prettyprint linenums"><code>rpm -ql tomcat-lib                  # 通过此命令查看.jar文件存放的目录，就是类库文件的目录<br />
/usr/share/java/tomcat/             # yum安装的tomcat类库路径<br />
/usr/local/tomcat/lib               # 在官网rpm安装的tomcat类库路径</code></pre></li>
<li><p>添加测试页面<br />下面两个测试页面各不相相同，所以要在各自的目录下分别创建。<br /><strong>在tomcatA中添加测试页面</strong></p>
<pre class="prettyprint linenums"><code>shell &gt; mkdir -pv /usr/local/tomcat/webapps/test/WEB-INF/{classes,lib}<br />
shell &gt; vim /usr/local/tomcat/webapps/test/index.jsp<br />
添加如下内容：<br />
&lt;%@ page language="java" %&gt;<br />
&lt;html&gt;<br />
  &lt;head&gt;&lt;title&gt;TomcatA&lt;/title&gt;&lt;/head&gt;<br />
  &lt;body&gt;<br />
&lt;h1&gt;&lt;font color="red"&gt;TomcatA.magedu.com&lt;/font&gt;&lt;/h1&gt;<br />
&lt;table align="centre" border="1"&gt;<br />
  &lt;tr&gt;<br />
    &lt;td&gt;Session ID&lt;/td&gt;<br />
&lt;% session.setAttribute("magedu.com","magedu.com"); %&gt;<br />
    &lt;td&gt;&lt;%= session.getId() %&gt;&lt;/td&gt;<br />
  &lt;/tr&gt;<br />
  &lt;tr&gt;<br />
    &lt;td&gt;Created on&lt;/td&gt;<br />
    &lt;td&gt;&lt;%= session.getCreationTime() %&gt;&lt;/td&gt;<br />
 &lt;/tr&gt;<br />
&lt;/table&gt;<br />
  &lt;/body&gt;<br />
&lt;/html&gt;</code></pre>
<p><strong>在tomcatB中添加测试页面</strong></p>
<pre class="prettyprint linenums"><code>shell &gt; mkdir -pv /usr/local/tomcat/webapps/test/WEB-INF/{classes,lib}<br />
shell &gt; vim /usr/local/tomcat/webapps/test/index.jsp<br />
&lt;%@ page language="java" %&gt;<br />
&lt;html&gt;<br />
&lt;head&gt;&lt;title&gt;TomcatB&lt;/title&gt;&lt;/head&gt;<br />
    &lt;body&gt;<br />
    &lt;h1&gt;&lt;font color="blue"&gt;TomcatB.magedu.com&lt;/font&gt;&lt;/h1&gt;<br />
    &lt;table align="centre" border="1"&gt;<br />
        &lt;tr&gt;<br />
            &lt;td&gt;Session ID&lt;/td&gt;<br />
        &lt;% session.setAttribute("magedu.com","magedu.com"); %&gt;<br />
            &lt;td&gt;&lt;%= session.getId() %&gt;&lt;/td&gt;<br />
        &lt;/tr&gt;<br />
        &lt;tr&gt;<br />
            &lt;td&gt;Created on&lt;/td&gt;<br />
            &lt;td&gt;&lt;%= session.getCreationTime() %&gt;&lt;/td&gt;<br />
        &lt;/tr&gt;<br />
    &lt;/table&gt;<br />
    &lt;/body&gt;<br />
&lt;/html&gt; </code></pre></li>
<li><p>启动服务</p>
<pre class="prettyprint linenums"><code>systemctl start tomcat</code></pre></li></ul>
<h2>四、Memcached配置</h2>
<p>Mechached基本没有什么配置的，安装上启动服务即可.</p>
<pre class="prettyprint linenums"><code>yum install memcached<br />
systemctl start memcached</code></pre>
<h2>五、测试</h2>
<p>使用浏览器访问http://172.18.68.11,然后多次刷新，只要SessionID这一栏的数值不变就说明session已经保持不变</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1248689/201711/1248689-20171121113020883-1557542856.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1248689/201711/1248689-20171121113027008-853082360.png" /></p>
<p>在<a href="http://www.linuxidc.com/topicnews.aspx?tid=2" rel="external nofollow noreferrer">Ubuntu</a>&nbsp;17.10上安装LAMP（Apache，MariaDB，PHP7.1）&nbsp;&nbsp;<a href="http://www.linuxidc.com/Linux/2017-10/148065.htm" rel="external nofollow noreferrer">http://www.linuxidc.com/Linux/2017-10/148065.htm</a></p>
<p>Ubuntu 17.10上使用Apache+MariaDB+PHP7.1安装WordPress&nbsp;&nbsp;<a href="http://www.linuxidc.com/Linux/2017-10/148066.htm" rel="external nofollow noreferrer">http://www.linuxidc.com/Linux/2017-10/148066.htm</a></p>
<p><strong>本文永久更新链接地址</strong>：<a href="http://www.linuxidc.com/Linux/2017-11/148718.htm" rel="external nofollow noreferrer">http://www.linuxidc.com/Linux/2017-11/148718.htm</a></p>
<p>转载自aubin</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390mprj8.html">mysqlDBA&lpar;1-3年&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2j1738.html">C&num; 发送邮件中包含图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/3901dm38.html">Maven基础使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql6x6eq.html">java&period;lang&period;RuntimeException&colon; Fail to connect to camera service问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/49554y09.html">Java 杨辉三角的简单实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1ggm6q.html">CPU boot up过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y574nq.html">like的性能问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1x4wg8.html">Unity3D基础学习 NGUI自带Tooltip制作提示文字</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok6e2e9.html">php 通过ip获取地理位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1yr0r9.html">poj 1753 Flip Game（bfs状态压缩 或 dfs枚举）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpz0e59.html">delete和delete&lbrack;&rsqb;的区别&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdngn09.html">Dynamics 365&mdash;脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdww5nz9.html">Avro序列化与反序列化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jj5znq.html">springboot Aop 统一处理Web请求日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ryg768.html">使用IntelliJ IDEA创建简单的Dubbo实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rxvpj9.html">cocos2d JS-&lpar;JavaScript&rpar; cc&period;each循环遍历对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp5ppz9.html">Mac上如何用命令修改文件内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvejzkj9.html">完善：HTML5表单新特征简介与举例&mdash;&mdash;张鑫旭</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk7zxx8.html">jq对象和DOM对象的互换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvelnoy9.html">【题解】前k大子段和</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q251nv3q.html">占满屏幕的宽高&comma;当把textarea换成其他标签的时候，怎么才能编辑&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1rpjlq.html">CF718C Sasha and Array 线段树&plus;矩阵加速</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw56ok8.html">DMA驱动框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy7wkv9.html">008-ThreadLocal原理分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5lx1mq.html">UltraISO 9&period;7&period;0&period;3476中文完美破解安装版</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw5l1k8.html">构造器初始化（static）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w1epwq.html">&lbrack;django&rsqb;django查询最佳实战</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5lexeq.html">Linux下Nginx安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4knpe9.html">PHP三种访问控制模式（public、protected、private）解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1r7d5q.html">one-hot句子向量   对比度增强</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
